// C++ code
//This program begins to receive input from the ultrasonic distance sensor
//once the distance is less than 8 cm
//and then based on the distance it reads it will move the servors backwards
//to a 90 degree position

#include <Servo.h>

Servo servo_2; //Name both servos
Servo servo_4;
const int pingPin1 = 7;  //Initialize I/O pins  
const int pingPin2 = 9;  //Initialize I/O pins
long duration1;  //Since PulseIn return an unsigned Long 
int distance1;  //To save the distance
long duration2;  //Since PulseIn return an unsigned Long 
int distance2;  //To save the distance

void setup()
{
  servo_2.attach(2);//attach servos to pins
  servo_4.attach(4);
 Serial.begin(9600);   //Initialize Serial communication
}


void loop(){
  distance1 = 0; //initialize distance variables
  distance2=0;
 pinMode(pingPin1, OUTPUT);   //Trigger pin as Output
  digitalWrite(pingPin1, LOW); //Make Trigger pin Low at start
  delayMicroseconds(3);
  digitalWrite(pingPin1, HIGH);
  delayMicroseconds(5);  //Make Trigger pin High for 5 uS to start sending the pulse
  digitalWrite(pingPin1, LOW);
  pinMode(pingPin1, INPUT);
  duration1 = pulseIn(pingPin1, HIGH);  //Save the time it took ultrasonic wave to come back
  
  pinMode(pingPin2, OUTPUT);   //Trigger pin as Output
  digitalWrite(pingPin2, LOW); //Make Trigger pin Low at start
  delayMicroseconds(3);
  digitalWrite(pingPin2, HIGH);
  delayMicroseconds(5);  //Make Trigger pin High for 5 uS to start sending the pulse
  digitalWrite(pingPin2, LOW);
  pinMode(pingPin2, INPUT);
  duration2 = pulseIn(pingPin2, HIGH);  //Save the time it took ultrasonic wave to come back
  
  distance1 = microsecondsToCentimeters(duration1); //convert from duration to distance in cm
  distance2 = microsecondsToCentimeters(duration2);
  Serial.println(distance1); //print distances 
  Serial.println(distance2);
  follow(); //Initializes the follow function
}

long microsecondsToCentimeters(long microseconds) {
  // The speed of sound is 340 m/s or 29 microseconds per centimeter.
  // The ping travels out and back, so to find the distance of the object we
  // take half of the distance travelled.
  return microseconds / 29 / 2;
}

void follow()
{
   if ((distance1<5)&&(distance2<5)){ //ensure both distances are met before beginning
    delay(3000); // 3 second delay to remove hand
    servo_4.write(90);  // tell servo 4 to go to position 90 degrees
    servo_2.write(45); // tell servo 9 to rotate backwards at 45 speed 
    delay(450); //0.45 second delay at 45 speed 
    servo_2.write(90); //tell servo 9 to stop
    delay(10000); //delay 10 seconds before returning to initial position 
   } else {
    servo_4.write(0); //leave servo 4 at initial zero position 
    servo_2.write(90); //pause servo 9
    delay(15); // Wait for 15 millisecond(s)
   }
}
